local assets=
{
	Asset("ANIM", "anim/amulet.zip"),
	Asset("ANIM", "anim/torso_amulet.zip"),
	Asset("ATLAS", "images/inventoryimages/obsidianamulet.xml"),
	Asset("IMAGE", "images/inventoryimages/obsidianamulet.tex"),

}



local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_body", "torso_amulet", "swap_body")
    owner:AddTag("noburning")
    if inst.components.fueled then
        inst.components.fueled:StartConsuming()        
    end

end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    owner:RemoveTag("noburning")
    if inst.components.fueled then
        inst.components.fueled:StopConsuming()        
    end
end


local function onfinished(inst)
    inst:Remove()

end


local function commonfn()
	local inst = CreateEntity()
    
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)   

    MakeInventoryFloatable(inst, "idle", "idle")
    inst.AnimState:PlayAnimation("idle")

    inst.AnimState:SetBank("amulet")
    inst.AnimState:SetBuild("amulet")
    
    inst:AddComponent("inspectable")
	
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.BODY



    
    return inst
end


local function obsidian(inst)
    local inst = commonfn(inst)


    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "obsidianamulet"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/obsidianamulet.xml"
	inst.components.inventoryitem.foleysound = "dontstarve_DLC002/common/foley/obsidian_armour"

    inst:AddComponent("heater")
    inst.components.heater.iscooler = true
    inst.components.heater.equippedheat = TUNING.BLUEGEM_COOLER


    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "MAGIC"
    inst.components.fueled:InitializeFuelLevel(TUNING.BLUEAMULET_FUEL)
    inst.components.fueled:SetDepletedFn(onfinished)

    inst.AnimState:PlayAnimation("swap_body")
    inst.components.equippable:SetOnEquip( onequip)
    inst.components.equippable:SetOnUnequip( onunequip )

    inst:AddComponent("dapperness")
    inst.components.dapperness.dapperness = -TUNING.DAPPERNESS_MED    

    return inst
end




return Prefab("common/inventory/obsidianamulet", obsidian, assets)
