local assets=
{
	Asset("ANIM", "anim/obsidiancane.zip"),
	Asset("ANIM", "anim/swap_obsidiancane.zip"),
	Asset("IMAGE", "images/inventoryimages/obsidiancane.tex"),   
    Asset("ATLAS", "images/inventoryimages/obsidiancane.xml"),
	Asset("ANIM", "anim/ui_sg_1x1_3.zip"), 
    
}

local function onattack_ice(inst, owner, target)
    local pt = owner:GetPosition()
    if target.components.health and not target:HasTag("wall") then
	   SpawnPrefab("die_fx").Transform:SetPosition(target.Transform:GetWorldPosition())
	   target.Transform:SetPosition(pt.x+1, pt.y, pt.z)
	   SpawnPrefab("die_fx").Transform:SetPosition(target.Transform:GetWorldPosition())
    end
	if target.components.freezable then
        target.components.freezable:Freeze(1) --Does this break ice staff?
    end
	inst.components.container:ConsumeByName("ice", 1)
end

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_obsidiancane", "swap_cane")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
	inst.components.container:Open(owner)
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
	inst.components.container:Close(owner)
end


local slotpos = {}

	table.insert(slotpos, Vector3(-123, 10 ,0))

local function itemtest(inst, item, slot)
	return item.prefab == "ice"
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()        
    MakeInventoryPhysics(inst)
    
    anim:SetBank("cane")
    anim:SetBuild("obsidiancane")
    anim:PlayAnimation("idle")
    
    MakeInventoryFloatable(inst, "idle_water", "idle")
    
    inst:AddComponent("weapon")
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "obsidiancane"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/obsidiancane.xml"
    
    inst:AddComponent("equippable")
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    inst.components.equippable.walkspeedmult = TUNING.CANE_SPEED_MULT*1.5
    
	inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_sg_1x1_3"
    inst.components.container.widgetpos = Vector3(-150,-300,0)
	inst.components.container.widgetpos_controller = Vector3(-150,-300,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "magazine"
	
	inst:DoPeriodicTask(0.1, function()
	
	if not GetPlayer().components.inventory:IsItemEquipped(inst) then
	inst.components.container.canbeopened = false
	else
	inst.components.container.canbeopened = true
	end
	
    if inst.components.container:IsFull() then
    inst.components.weapon:SetOnAttack(onattack_ice) 
	inst.components.weapon:SetDamage(0)
    inst.components.weapon:SetRange(20,25)
	
    elseif
	
    inst.components.container:IsEmpty() then
	inst.components.weapon:SetOnAttack(nil)
    inst.components.weapon:SetDamage(TUNING.CANE_DAMAGE)
    inst.components.weapon:SetRange(0)
    end
	
end)
    return inst
end


return Prefab( "common/inventory/obsidiancane", fn, assets) 

