local assets=
{
    Asset("ANIM", "anim/obsidianhandcannon.zip"),
    Asset("ANIM", "anim/swap_obsidianhandcannon.zip"),

    Asset("IMAGE", "images/inventoryimages/obsidianhandcannon.tex"),   
    Asset("ATLAS", "images/inventoryimages/obsidianhandcannon.xml"),

    Asset("ANIM", "anim/ui_sg_1x1.zip"), 
}
 
 
 
local prefabs =
{

    "die_fx",    
    "maxwell_smoke",
    "explode_small",
	
}

 
local function onfinished(inst)

    inst.components.container:DropEverything()
    inst:Remove()
   

end
 
local function onequip(inst, owner)

    owner.AnimState:OverrideSymbol("swap_object", "swap_obsidianhandcannon", "swap_speargun")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    inst.components.container:Open(owner)
	

end
 
local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    inst.components.container:Close(owner)

end



local function onattack_gun(inst, owner, target)

    --if owner.components.health and owner.components.health:GetPercent() < 1.1 and not target:HasTag("wall")and not target:HasTag("ghost") then
       -- owner.components.health:DoDelta(-5) 
	   -- target.components.burnable:Ignite()		
   -- end
    if OBSIDIANHANDCANNONFIRE and not GetWorld().components.seasonmanager:IsWetSeason() and target.components.burnable then
   
    target.components.burnable:Ignite()
	
	end
	


    inst.SoundEmitter:PlaySound("dontstarve/creatures/eyeballturret/shotexplo")
    SpawnPrefab("die_fx").Transform:SetPosition(target.Transform:GetWorldPosition())

    local smoke = SpawnPrefab("maxwell_smoke")
    local explode = SpawnPrefab("explode_small")
    local x,y,z = inst.Transform:GetWorldPosition()
    y = y + 1
    smoke.Transform:SetPosition(x,y,z)
    smoke.Transform:SetScale(.7,.7,.7)
    explode.Transform:SetPosition(x,y,z)
    explode.Transform:SetScale(.7,.7,.7)
    explode.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
    explode.AnimState:SetLightOverride(1)
    TheCamera:Shake("FULL", 0.2, 0.02, .5, 40)
    inst.components.container:ConsumeByName("bullet", 1)
    inst.components.container:Open(owner) 

end


local slotpos = {}

	table.insert(slotpos, Vector3(-123, 10 ,0))

local function itemtest(inst, item, slot)
	return item.prefab == "bullet"
end

local function fn()

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()

    inst.AnimState:SetBank("speargun")
    inst.AnimState:SetBuild("obsidianhandcannon")
    inst.AnimState:PlayAnimation("idle")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle_water", "idle")
     
    --inst:AddComponent("finiteuses")
    --inst.components.finiteuses:SetOnFinished( onfinished )
	--inst.components.finiteuses:SetMaxUses(100)
    --inst.components.finiteuses:SetUses(100)    

    inst:AddComponent("inspectable")
 
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "obsidianhandcannon"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/obsidianhandcannon.xml"
	inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/jewlery"


    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_sg_1x1"
    inst.components.container.widgetpos = Vector3(-150,-300,0)
	inst.components.container.widgetpos_controller = Vector3(-150,-300,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "magazine"
    
    inst:AddComponent("weapon")

    inst:DoPeriodicTask(0.1, function()
	
	if not GetPlayer().components.inventory:IsItemEquipped(inst) then
	inst.components.container.canbeopened = false
	else
	inst.components.container.canbeopened = true
	end
	
    if inst.components.container:IsFull() then
    inst.components.weapon:SetOnAttack(onattack_gun) 
    inst:RemoveTag("spear")
    inst:AddTag("speargun")
	inst:AddTag("projectile")
	inst.components.weapon:SetDamage(OBSIDIANHANDCANNONDAMAGE)
    inst.components.weapon:SetRange(15)
	
    elseif
	
    inst.components.container:IsEmpty() then
	inst:RemoveTag("projectile")
    inst:RemoveTag("speargun")
    inst:AddTag("spear")
    inst.components.weapon:SetDamage(10)
    inst.components.weapon:SetRange(0, 0)
    inst.components.weapon:SetOnAttack(nil)
	
    end
end)

    inst.components.equippable.equipstack = true
 
    return inst 
end
 
return Prefab( "common/inventory/obsidianhandcannon", fn, assets)