
local assets=
{
	Asset("ANIM", "anim/swap_obsidiantrident.zip"),
	Asset("ANIM", "anim/obsidiantrident.zip"),
	Asset("ANIM", "anim/ui_sg_1x1_2.zip"), 
	
	Asset("IMAGE", "images/inventoryimages/obsidiantrident.tex"),   
    Asset("ATLAS", "images/inventoryimages/obsidiantrident.xml"),
}

local prefabs = 
{
	"impact",
}

local pt = nil
local lifebuoy = nil
local pos = nil
local ents = nil

local function onfinished(inst)
    inst.components.container:DropEverything()
	inst:Remove()
end

local function onequip(inst, owner) 
	owner.AnimState:OverrideSymbol("swap_object", "swap_obsidiantrident", "swap_obsidiantrident")
	owner.AnimState:Show("ARM_carry") 
	owner.AnimState:Hide("ARM_normal")

	inst.components.container:Open(owner)	
	inst.Light:Enable(true)
    inst.Light:SetFalloff(0.4)
    inst.Light:SetIntensity(.7)
    inst.Light:SetRadius(0.5)
    inst.Light:SetColour(255/255, 69/255, 0/255)
    inst.SoundEmitter:PlaySound("dontstarve/wilson/lighter_LP", "torch")
    inst.fire = SpawnPrefab( "lighterfire" )
    inst.fire.Transform:SetScale(100,100,100)
    local follower = inst.fire.entity:AddFollower()
    follower:FollowSymbol( owner.GUID, "swap_object", 0, -200, 1 )


end

local function onunequip(inst, owner) 
	owner.AnimState:ClearOverrideSymbol("swap_object")
	owner.AnimState:Hide("ARM_carry") 
	owner.AnimState:Show("ARM_normal") 
    inst.Light:Enable(false)
    inst.components.container:Close(owner)
	
	if inst.fire then 
	inst.fire:Remove()
    inst.fire = nil
	
	inst.SoundEmitter:KillSound("torch")
	inst.SoundEmitter:PlaySound("dontstarve/wilson/lighter_off")   
   end 
end

local function onhit(inst, attacker, target)
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.Default)
	inst.AnimState:PlayAnimation("idle")
	
	local impactfx = SpawnPrefab("impact")
	if impactfx and attacker then
		local follower = impactfx.entity:AddFollower()
		follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
		impactfx:FacePoint(attacker.Transform:GetWorldPosition())
	end
	
	
end

local function thrownfn(inst)
	inst.AnimState:PlayAnimation("thrown")
end

local function onthrown(inst, data)
	inst.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
end

local function ondropped(inst)


end

local function onpickup(inst)


end


local slotpos = {}

	table.insert(slotpos, Vector3(-123, 10 ,0))

local function itemtest(inst, item, slot)
	return item.prefab == "dragoonheart"
end

local function fn()
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()

	MakeInventoryPhysics(inst)
	MakeInventoryFloatable(inst, "idle_water", "idle")
	
	inst.AnimState:SetBank("obsidiantrident")
	inst.AnimState:SetBuild("obsidiantrident")
	inst.AnimState:PlayAnimation("idle")
	
	--inst:AddTag("thrown")
	--inst:AddTag("projectile")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "obsidiantrident"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/obsidiantrident.xml"
	
	inst:AddComponent("weapon")
	inst.components.weapon:SetRange(0.5,0.5)
    inst:AddTag("spear")

	--inst:AddComponent("finiteuses")
	--inst.components.finiteuses:SetMaxUses(TUNING.HARPOON_USES)
	--inst.components.finiteuses:SetUses(TUNING.HARPOON_USES)
	--inst.components.finiteuses:SetOnFinished(onfinished)

	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)


	--inst:ListenForEvent("onthrown", onthrown)
	--inst:ListenForEvent("ondropped", ondropped)
    --inst:ListenForEvent( "onpickup",onpickup)
	
	inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_sg_1x1_2"
    inst.components.container.widgetpos = Vector3(-150,-300,0)
	inst.components.container.widgetpos_controller = Vector3(-150,-300,0)
    inst.components.container.side_widget = true
    inst.components.container.type = "magazine"
	
	local light = inst.entity:AddLight()
	light:SetFalloff(0.4)
    light:SetIntensity(.7)
    light:SetRadius(0.5)
    light:SetColour(255/255, 69/255, 0/255)
    light:Enable(true)
	

	inst:DoPeriodicTask(0.1, function()
	
	if not GetPlayer().components.inventory:IsItemEquipped(inst) then
	inst.components.container.canbeopened = false
	else
	inst.components.container.canbeopened = true
	end
	
	
    if inst.components.container:IsFull() then
	--inst:RemoveTag("projectile")
    --inst:RemoveTag("thrown")
	if inst.components.container:Has("dragoonheart",10) then
	   inst.components.weapon:SetDamage(200)
	elseif inst.components.container:Has("dragoonheart",9) then
	   inst.components.weapon:SetDamage(180)
	elseif inst.components.container:Has("dragoonheart",8) then
	   inst.components.weapon:SetDamage(160)
	elseif inst.components.container:Has("dragoonheart",7) then
	   inst.components.weapon:SetDamage(140)
	elseif inst.components.container:Has("dragoonheart",6) then
	   inst.components.weapon:SetDamage(120)
	elseif inst.components.container:Has("dragoonheart",5) then
	   inst.components.weapon:SetDamage(100)
	elseif inst.components.container:Has("dragoonheart",4) then
	   inst.components.weapon:SetDamage(80)
	elseif inst.components.container:Has("dragoonheart",3) then
	   inst.components.weapon:SetDamage(60)
	elseif inst.components.container:Has("dragoonheart",2) then
	   inst.components.weapon:SetDamage(40)
	elseif inst.components.container:Has("dragoonheart",1) then
	   inst.components.weapon:SetDamage(20)
	else
	   inst.components.weapon:SetDamage(20)
	end	
	--inst.components.weapon:SetDamage(200)
	--inst.components.weapon:SetRange(0, 0)
	--inst:RemoveComponent("projectile")

	
	elseif inst.components.container:IsEmpty() then
    --inst:RemoveTag("spear")
	--inst:AddComponent("projectile")
	--inst.components.projectile:SetSpeed(TUNING.HARPOON_SPEED)
	--inst.components.projectile:SetOnHitFn(onhit)
	--inst.components.projectile:SetOnThrownFn(thrownfn)
	
	inst.components.weapon:SetDamage(1)
	--inst.components.weapon:SetRange(TUNING.HARPOON_RANGE, TUNING.HARPOON_RANGE+2)
	
    end
end)
	
	


	return inst
end

return Prefab( "common/inventory/obsidiantrident", fn, assets, prefabs)
